/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// 画面ロジック実行基底アクションクラス。
// 
//
//	変更履歴
//	2004/01/08 新規作成	T.Nishiki
//
package jp.co.ntt.lms.xms.framework.base;

import javax.servlet.http.HttpServletRequest;
import jp.co.ntt.lms.xms.framework.Constant;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsScreenAction;
import jp.co.ntt.lms.xms.framework.XmsSystemException;

/**
 * 画面ロジックＲＭＩ実行基底アクションクラス。<br>
 * ＲＭＩにてロジックを実行し、その実行した結果（LogicResult）は、
 * ActionResultBeanとしてまとめ、それをXmsResponseとして返却する。
 * このクラスでは、ＲＭＩ通じてのロジックの実行と
 * XmsResponseを返却するまで流れを実装し、
 * サブクラスでは、以下の内容を実装する。
 * <ol>
 * 	<li>実行するロジック。</li>
 * 	<li>ロジックの実行結果をＣＳＶファイルとするか否か。</li>
 * 	<li>ロジックの実行結果をＣＳＶファイルとする場合のロジック。</li>
 * </ol>
 * 
 * @see Logic
 * @see LogicResult
 * @see ActionResultBean
 * @see XmsResponse
 * @author nishiki
 */
public abstract class AbstractRmiAction extends XmsScreenAction {

	/**
	 * ロジッククラスの配列を戻す。<br>
	 * 各サブクラス実装者はリクエスト処理を完結するのに
	 * 必要なロジックを配列で戻すように実装する。
	 *
	 * @param xmsRequest リクエスト・オブジェクト
	 * @return ロジッククラスの配列。
	 * @throws XmsException ロジック取得時にエラーが発生した場合。
	 */
	protected abstract Logic[] getLogics(XmsRequest xmsRequest)
		throws XmsException;

	/**
	 * ＣＳＶファイルを生成するか判定する。<br>
	 * 各サブクラスのアクション実行後、JSPフォワードする際、
	 * ＣＳＶファイルを作成する場合にはtrueを戻し、
	 * 不要の場合、falseを戻すように設定する。
	 * このクラスでtrueを戻すように実装しているので、
	 * 不要な場合のみ、falseを戻す実装でオーバーライドすること。
	 * @return 生成が必要な場合、trueを戻す。<br>
	 */
	protected boolean csvFileIsRequired() {
		return true;
	}

	/**
	 * 初期化処理。<br>
	 * このクラスでfinal宣言しているprocessRequestメソッドの前に実行する。
	 * 空定義しているので、初期化などの処理が必要な場合、
	 * 各サブクラスにて、このメソッドをオーバーライドする。
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 */
	protected void initProcessRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {
	}

	/**
	 * アクション実行処理。<br>
	 * getLogicsメソッドで取得したロジックをRMIを利用して、
	 * RMIサーバで実行し、その結果を順次取得する。
	 * それら結果をActionResultBeanでまとめて、
	 * XmsResponseに格納する。
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @see ActionResultBean
	 * @see #getLogics(XmsRequest)
	 */
	protected final void processRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {

		// RMIクライアント
		RemoteLogicClient remote = null;
		// 実行するロジックの配列
		Logic[] logics = null;
		// 実行したロジックの結果
		LogicResult result = null;
		// ロジック結果をまとめ役
		ActionResultBean bean = null;
		// 出力形式
		int type = 0;
		// 要求形式
		String mode = null;
		// リクエスト・パラメータ取得用
		HttpServletRequest request = null;

		try {
			// =================================================================
			// ロジック取得
			logics = getLogics(xmsRequest);

			bean = new ActionResultBean();
			// =================================================================
			// RMI呼び出しを実行して、ロジック実行処理を
			// RMIサーバー側で実行。
			// 結果をリクエストの属性として設定。
			remote = new RemoteLogicClient();
			for (int i = 0; i < logics.length; i++) {
				result = remote.doLogic(logics[i]);

				bean.addLogicResult(result);
			}
			// =================================================================
			// beanをレスポンスオブジェクトに格納
			xmsResponse.setScreenBean(bean);
			// =================================================================
			// ビジネスロジック後の処理を設定
			// 要求内容
			request = xmsRequest.getRequest();
			mode = request.getParameter(Constant.REQUEST_MODE);
			if ((mode != null)
				&& (mode.equals(Constant.REQUEST_VALUE_MODE_CSV) == true)) {
				// CSV指定の場合、ダウンロード
				type = XmsResponse.DOWNLOAD;
			} else {
				boolean required = csvFileIsRequired();
				if (required == true) {
					// 通常はCSVファイルを作成後、JSPにフォワード
					type = XmsResponse.JSP_CSV;
				} else {
					// CSVファイル作成しない場合は、JSPにフォワード
					type = XmsResponse.JSP;
				}
			}
			xmsResponse.setOutType(type);
		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsSystemException(e);
		}
	}

}
